searchData={"items":[{"type":"module","title":"Dreamy","doc":"Dreamy provides useful macros, functions, types & operators to make elixir even dreamier 😴","ref":"Dreamy.html"},{"type":"macro","title":"Dreamy.>>>/2","doc":"Operator for Enum.map","ref":"Dreamy.html#%3E%3E%3E/2"},{"type":"macro","title":"Examples - Dreamy.>>>/2","doc":"```\niex> use Dreamy\n...> x = fn y -> y + 1 end\n...> y = fn z -> z * 2 end\n...> [1, 2]\n...> >>> x\n...> >>> y\n[4, 6]\n\niex> use Dreamy\n...> x = fn y -> y - 1 end\n...> [5, 7]\n...> >>> x\n...> >>> (&div(&1, 2))\n...> >>> x\n[1, 2]\n```","ref":"Dreamy.html#%3E%3E%3E/2-examples"},{"type":"macro","title":"Dreamy.const/2","doc":"Macro for defining a constant attribute and function","ref":"Dreamy.html#const/2"},{"type":"macro","title":"Examples - Dreamy.const/2","doc":"```\niex> use Dreamy\niex> const :example, \"XYZ\"\niex> @example\n\"XYZ\"\n\niex> example()\n\"XYZ\"\n```","ref":"Dreamy.html#const/2-examples"},{"type":"macro","title":"Dreamy.fallthrough/2","doc":"Macro for adding a default catchall -> clause to case statements, that returns the input value","ref":"Dreamy.html#fallthrough/2"},{"type":"macro","title":"Examples - Dreamy.fallthrough/2","doc":"```\niex> use Dreamy\n...> fallthrough {:error, \"error\"} do\n...> {:ok, v} -> v\n...> end\n{:error, \"error\"}\n\niex> use Dreamy\n...> fallthrough {:ok, \"OK\"} do\n...> {:ok, \"OK\"} -> \"OK\"\n...> end\n\"OK\"\n```","ref":"Dreamy.html#fallthrough/2-examples"},{"type":"macro","title":"Dreamy.or_else/2","doc":"Macro for adding a default catchall `true` clause to cond statements, that returns the default value","ref":"Dreamy.html#or_else/2"},{"type":"macro","title":"Examples - Dreamy.or_else/2","doc":"```\niex> use Dreamy\n...> x = 5\n...> or_else \"Less than 10\" do\n...> x == 10 -> \"10\"\n...> x > 10 -> \"Greater than 10\"\n...> end\n\"Less than 10\"\n\niex> use Dreamy\n...> x = 11\n...> or_else \"Less than 10\" do\n...> x == 10 -> \"10\"\n...> x > 10 -> \"Greater than 10\"\n...> end\n\"Greater than 10\"\n```","ref":"Dreamy.html#or_else/2-examples"},{"type":"macro","title":"Dreamy.otherwise/3","doc":"Macro for adding a default catchall -> clause to case statements, that returns the default value","ref":"Dreamy.html#otherwise/3"},{"type":"macro","title":"Examples - Dreamy.otherwise/3","doc":"```\niex> use Dreamy\n...> otherwise nil, {:error, :not_found} do\n...> {:ok, _} -> :ok\n...> end\n{:error, :not_found}\n\niex> use Dreamy\n...> otherwise {:ok, nil}, {:error, :not_found} do\n...> {:ok, _} -> :ok\n...> end\n:ok\n```","ref":"Dreamy.html#otherwise/3-examples"},{"type":"module","title":"Dreamy.Monodic","doc":"Functions for use with both Result and Option monads","ref":"Dreamy.Monodic.html"},{"type":"function","title":"Dreamy.Monodic.flat_map/2","doc":"Alias for ~>>","ref":"Dreamy.Monodic.html#flat_map/2"},{"type":"function","title":"Dreamy.Monodic.flatten/1","doc":"Function that flattens monads containing other monads","ref":"Dreamy.Monodic.html#flatten/1"},{"type":"function","title":"Result Examples - Dreamy.Monodic.flatten/1","doc":"```\niex> use Dreamy\n...> flatten(ok(ok(\"Hello World\")))\n{:ok, \"Hello World\"}\n\niex> use Dreamy\n...> flatten(ok(error(\"Hello World\")))\n{:error, \"Hello World\"}\n\niex> use Dreamy\n...> flatten(error(ok(\"Hello World\")))\n{:ok, \"Hello World\"}\n\niex> use Dreamy\n...> flatten(error(error(\"Hello World\")))\n{:error, \"Hello World\"}\n```","ref":"Dreamy.Monodic.html#flatten/1-result-examples"},{"type":"function","title":"Option Examples - Dreamy.Monodic.flatten/1","doc":"```\niex> use Dreamy\n...> flatten(option(option(\"Hello World\")))\n{Option, \"Hello World\"}\n\niex> use Dreamy\n...> flatten(option(empty()))\n{Option, :empty}\n```","ref":"Dreamy.Monodic.html#flatten/1-option-examples"},{"type":"macro","title":"Dreamy.Monodic.is_monodic/1","doc":"","ref":"Dreamy.Monodic.html#is_monodic/1"},{"type":"function","title":"Dreamy.Monodic.map/2","doc":"Alias for ~>","ref":"Dreamy.Monodic.html#map/2"},{"type":"function","title":"Dreamy.Monodic.~>/2","doc":"Function for applying result tuples & options on success only","ref":"Dreamy.Monodic.html#~%3E/2"},{"type":"function","title":"Result Examples - Dreamy.Monodic.~>/2","doc":"```\niex> use Dreamy\n...> {:ok, 1}\n...> ~> fn x -> {:ok, x + 1} end\n...> ~> fn y -> y + 1 end\n3\n\niex> use Dreamy\n...> {:error, 1}\n...> ~> fn x -> x + 1 end\n{:error, 1}\n```","ref":"Dreamy.Monodic.html#~%3E/2-result-examples"},{"type":"function","title":"Option Examples - Dreamy.Monodic.~>/2","doc":"```\niex> use Dreamy\n...> empty()\n...> ~> (fn _ -> :ok end)\n{Dreamy.Option, :empty}\n\niex> use Dreamy\n...> option(1)\n...> ~> (fn x -> x + 1 end)\n{Dreamy.Option, 2}\n```","ref":"Dreamy.Monodic.html#~%3E/2-option-examples"},{"type":"function","title":"Dreamy.Monodic.~>>/2","doc":"Function for applying result tuples & options on success only","ref":"Dreamy.Monodic.html#~%3E%3E/2"},{"type":"function","title":"Result Examples - Dreamy.Monodic.~>>/2","doc":"```\niex> use Dreamy\n...> {:ok, 1}\n...> ~>> fn x -> {:ok, x + 1} end\n...> ~>> fn x -> {:ok, x * 2} end\n{:ok, 4}\n\niex> use Dreamy\n...> {:error, 1}\n...> ~>> fn {:ok, x} -> {:ok, x + 1} end\n{:error, 1}\n```","ref":"Dreamy.Monodic.html#~%3E%3E/2-result-examples"},{"type":"function","title":"Option Examples - Dreamy.Monodic.~>>/2","doc":"```\niex> use Dreamy\n...> empty()\n...> ~>> (fn x -> option(x + 2) end)\n{Dreamy.Option, :empty}\n\niex> use Dreamy\n...> option(1)\n...> ~>> (fn x -> option(x + 2) end)\n{Dreamy.Option, 3}\n```","ref":"Dreamy.Monodic.html#~%3E%3E/2-option-examples"},{"type":"module","title":"Dreamy.Option","doc":"Functions for use with Options","ref":"Dreamy.Option.html"},{"type":"function","title":"Dreamy.Option.empty/0","doc":"","ref":"Dreamy.Option.html#empty/0"},{"type":"function","title":"Dreamy.Option.from_result/1","doc":"Build an Option from a Result","ref":"Dreamy.Option.html#from_result/1"},{"type":"function","title":"Examples - Dreamy.Option.from_result/1","doc":"```\niex> use Dreamy\n...> from_result({:error, \"err\"})\n{Dreamy.Option, :empty}\n\niex> use Dreamy\n...> from_result({:ok, \"OK\"})\n{Dreamy.Option, \"OK\"}\n```","ref":"Dreamy.Option.html#from_result/1-examples"},{"type":"function","title":"Dreamy.Option.get/1","doc":"Get the value of an option","ref":"Dreamy.Option.html#get/1"},{"type":"function","title":"Examples - Dreamy.Option.get/1","doc":"```\niex> use Dreamy\n...> empty()\n...> |> get()\n:error\n\niex> use Dreamy\n...> option(\"Hello World\")\n...> |> get()\n{:ok, \"Hello World\"}\n```","ref":"Dreamy.Option.html#get/1-examples"},{"type":"function","title":"Dreamy.Option.get!/1","doc":"Get the value of an option, throwing an error if empty","ref":"Dreamy.Option.html#get!/1"},{"type":"function","title":"Examples - Dreamy.Option.get!/1","doc":"```\niex> use Dreamy\n...> empty()\n...> |> get!()\n** (RuntimeError) Empty Option\n\niex> use Dreamy\n...> option(\"Hello World\")\n...> |> get!()\n\"Hello World\"\n```","ref":"Dreamy.Option.html#get!/1-examples"},{"type":"macro","title":"Dreamy.Option.is_empty/1","doc":"","ref":"Dreamy.Option.html#is_empty/1"},{"type":"macro","title":"Dreamy.Option.is_option/1","doc":"Returns an empty Option","ref":"Dreamy.Option.html#is_option/1"},{"type":"macro","title":"Examples - Dreamy.Option.is_option/1","doc":"```\niex> use Dreamy\n...> empty()\n{Dreamy.Option, :empty}\n```","ref":"Dreamy.Option.html#is_option/1-examples"},{"type":"function","title":"Dreamy.Option.option/1","doc":"builds an Option from a value","ref":"Dreamy.Option.html#option/1"},{"type":"function","title":"Examples - Dreamy.Option.option/1","doc":"```\niex> use Dreamy\n...> option(nil)\n{Dreamy.Option, :empty}\n\niex> use Dreamy\n...> empty() == option(nil)\ntrue\n\niex> use Dreamy\n...> option(\"Hello World\")\n{Dreamy.Option, \"Hello World\"}\n```","ref":"Dreamy.Option.html#option/1-examples"},{"type":"function","title":"Dreamy.Option.to_result/1","doc":"Build an Result from an Option","ref":"Dreamy.Option.html#to_result/1"},{"type":"function","title":"Examples - Dreamy.Option.to_result/1","doc":"```\niex> use Dreamy\n...> empty()\n...> |> to_result()\n{:error, nil}\n\niex> use Dreamy\n...> option(\"OK\")\n...> |> to_result()\n{:ok, \"OK\"}\n```","ref":"Dreamy.Option.html#to_result/1-examples"},{"type":"type","title":"Dreamy.Option.t/1","doc":"","ref":"Dreamy.Option.html#t:t/1"},{"type":"module","title":"Dreamy.Result","doc":"Functions for use with :ok, and :error tuples","ref":"Dreamy.Result.html"},{"type":"function","title":"Dreamy.Result.error/1","doc":"Returns an error Result","ref":"Dreamy.Result.html#error/1"},{"type":"function","title":"Examples - Dreamy.Result.error/1","doc":"```\niex> use Dreamy\n...> error(\"err\")\n{:error, \"err\"}\n```","ref":"Dreamy.Result.html#error/1-examples"},{"type":"function","title":"Dreamy.Result.flip/1","doc":"Function for flipping results","ref":"Dreamy.Result.html#flip/1"},{"type":"function","title":"Examples - Dreamy.Result.flip/1","doc":"```\niex> use Dreamy\n...> flip({:ok, 3})\n{:error, 3}\n\niex> use Dreamy\n...> flip({:error, 3})\n{:ok, 3}\n```","ref":"Dreamy.Result.html#flip/1-examples"},{"type":"function","title":"Dreamy.Result.from_option/1","doc":"Build an Result from an Option","ref":"Dreamy.Result.html#from_option/1"},{"type":"function","title":"Examples - Dreamy.Result.from_option/1","doc":"```\niex> use Dreamy\n...> empty()\n...> |> from_option()\n{:error, nil}\n\niex> use Dreamy\n...> option(\"OK\")\n...> |> from_option()\n{:ok, \"OK\"}\n```","ref":"Dreamy.Result.html#from_option/1-examples"},{"type":"macro","title":"Dreamy.Result.is_error/1","doc":"","ref":"Dreamy.Result.html#is_error/1"},{"type":"macro","title":"Dreamy.Result.is_ok/1","doc":"","ref":"Dreamy.Result.html#is_ok/1"},{"type":"macro","title":"Dreamy.Result.is_result/1","doc":"","ref":"Dreamy.Result.html#is_result/1"},{"type":"function","title":"Dreamy.Result.ok/1","doc":"Returns an empty Option","ref":"Dreamy.Result.html#ok/1"},{"type":"function","title":"Examples - Dreamy.Result.ok/1","doc":"```\niex> use Dreamy\n...> ok(\"Hello World\")\n{:ok, \"Hello World\"}\n```","ref":"Dreamy.Result.html#ok/1-examples"},{"type":"function","title":"Dreamy.Result.to_option/1","doc":"Function to convert results to options","ref":"Dreamy.Result.html#to_option/1"},{"type":"function","title":"Examples - Dreamy.Result.to_option/1","doc":"```\niex> use Dreamy\n...> to_option({:ok, 3})\n{Dreamy.Option, 3}\n\niex> use Dreamy\n...> to_option({:error, 3})\n{Dreamy.Option, :empty}\n```","ref":"Dreamy.Result.html#to_option/1-examples"},{"type":"function","title":"Dreamy.Result.unwrap/1","doc":"Function for extracting values from :ok records","ref":"Dreamy.Result.html#unwrap/1"},{"type":"function","title":"Examples - Dreamy.Result.unwrap/1","doc":"```\niex> use Dreamy\n...> {:ok, \"hello\"}\n...> |> unwrap\n\"hello\"\n\niex> use Dreamy\n...> {:error, \"world\"}\n...> |> unwrap\n{:error, \"world\"}\n```","ref":"Dreamy.Result.html#unwrap/1-examples"},{"type":"function","title":"Dreamy.Result.unwrap_error/1","doc":"Function for extracting values from :error tuples","ref":"Dreamy.Result.html#unwrap_error/1"},{"type":"function","title":"Examples - Dreamy.Result.unwrap_error/1","doc":"```\niex> use Dreamy\n...> {:ok, \"hello\"}\n...> |> unwrap_error\n{:ok, \"hello\"}\n\niex> use Dreamy\n...> {:error, \"world\"}\n...> |> unwrap_error\n\"world\"\n```","ref":"Dreamy.Result.html#unwrap_error/1-examples"},{"type":"function","title":"Dreamy.Result.|||/2","doc":"Function getting the first :ok result if one exists","ref":"Dreamy.Result.html#%7C%7C%7C/2"},{"type":"function","title":"Examples - Dreamy.Result.|||/2","doc":"```\niex> use Dreamy\n...> {:ok, \"success\"} ||| {:ok, \"success 2\"}\n{:ok, \"success\"}\n\niex> use Dreamy\n...> {:error, \"oops\"} ||| {:ok, \"success 2\"}\n{:ok, \"success 2\"}\n\niex> use Dreamy\n...> {:error, \"oops\"} ||| {:error, \"darn\"}\n{:error, \"oops\"}\n\niex> use Dreamy\n...> {:ok, \"first try\"} ||| {:error, \"darn\"} ||| {:ok, \"finally\"}\n{:ok, \"first try\"}\n\niex> use Dreamy\n...> {:error, \"oops\"} ||| {:error, \"darn\"} ||| {:ok, \"finally\"}\n{:ok, \"finally\"}\n```","ref":"Dreamy.Result.html#%7C%7C%7C/2-examples"},{"type":"type","title":"Dreamy.Result.t/2","doc":"Wrapper for :ok, and :error tuple","ref":"Dreamy.Result.html#t:t/2"},{"type":"module","title":"Dreamy.Types","doc":"Useful Type definitions","ref":"Dreamy.Types.html"},{"type":"type","title":"Dreamy.Types.enumerable/1","doc":"Type for documenting the value within an enumerable","ref":"Dreamy.Types.html#t:enumerable/1"},{"type":"type","title":"Dreamy.Types.nullable/1","doc":"Type union of `t` & `nil`","ref":"Dreamy.Types.html#t:nullable/1"},{"type":"type","title":"Dreamy.Types.option/1","doc":"Monodic type that can hold a value","ref":"Dreamy.Types.html#t:option/1"},{"type":"type","title":"Dreamy.Types.result/2","doc":"Monodic type for :ok, :error tuples","ref":"Dreamy.Types.html#t:result/2"},{"type":"extras","title":"Dreamy 😴","doc":"# Dreamy 😴\n\n[![ci](https://github.com/bwireman/dreamy/actions/workflows/elixir.yml/badge.svg?branch=main)](https://github.com/bwireman/dreamy/actions/workflows/elixir.yml)\n[![mit](https://img.shields.io/github/license/bwireman/dreamy?color=brightgreen)](https://github.com/bwireman/dreamy/blob/main/LICENSE)\n[![commits](https://img.shields.io/github/last-commit/bwireman/dreamy)](https://github.com/bwireman/dreamy/commit/main)\n[![0.2.1](https://img.shields.io/hexpm/v/dreamy?color=brightgreen&style=flat)](https://hexdocs.pm/dreamy/readme.html)\n[![downloads](https://img.shields.io/hexpm/dt/dreamy?color=brightgreen)](https://hex.pm/packages/dreamy/)\n[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen)](http://makeapullrequest.com)\n![Dreamy 😴](https://img.shields.io/badge/Dreamy%20%F0%9F%98%B4-blue)\n\nDreamy provides useful macros, functions, types & operators to make elixir even dreamier 😴\n\n# Operators\n\n- [>>>](https://hexdocs.pm/dreamy/Dreamy.html#%3E%3E%3E/2)\n- [~>](https://hexdocs.pm/dreamy/Dreamy.Monodic.html#~%3E/2)\n- [~>>](https://hexdocs.pm/dreamy/Dreamy.Monodic.html#~%3E%3E/2)\n- [|||](https://hexdocs.pm/dreamy/Dreamy.Result.html#%7C%7C%7C/2)\n\n# Macros\n\n- [fallthrough](https://hexdocs.pm/dreamy/Dreamy.html#fallthrough/2)\n- [otherwise](https://hexdocs.pm/dreamy/Dreamy.html#otherwise/3)\n- [const](https://hexdocs.pm/dreamy/Dreamy.html#const/2)\n- [or_else](https://hexdocs.pm/dreamy/Dreamy.html#or_else/2)\n\n# Functions\n\n- [unwrap](https://hexdocs.pm/dreamy/Dreamy.Result.html#unwrap/1)\n- [unwrap_error](https://hexdocs.pm/dreamy/Dreamy.Result.html#unwrap_error/1)\n- [flip](https://hexdocs.pm/dreamy/Dreamy.Result.html#flip/1)\n\n# Types\n\n- [`nullable(t)`](https://hexdocs.pm/dreamy/Dreamy.Types.html#t:nullable/1)\n- [`result(ok, error)`](https://hexdocs.pm/dreamy/Dreamy.Types.html#t:result/2)\n- [`option(t)`](https://hexdocs.pm/dreamy/Dreamy.Types.html#t:option/1)\n- [`enumerable(_t)`](https://hexdocs.pm/dreamy/Dreamy.Types.html#t:enumerable/1)","ref":"readme.html"},{"type":"extras","title":"Installation - Dreamy 😴","doc":"[Available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `dreamy` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:dreamy, \"~> 0.2.1\"}\n  ]\nend\n```","ref":"readme.html#installation"}],"content_type":"text/markdown"}